import * as AwsDynamoDB from 'aws-sdk/clients/dynamodb';
import { Observable } from 'rxjs';
import { OutputStream } from 'mutator-io';
declare global  {
    interface SymbolConstructor {
        observable: symbol;
    }
}
declare class DynamoDB implements OutputStream<DynamoDB.Message> {
    config: DynamoDB.Config;
    client: AwsDynamoDB.DocumentClient;
    static defaultConfig: DynamoDB.Config;
    constructor(config?: DynamoDB.Config);
    create(): (msg: DynamoDB.Message, scheduler: any) => Observable<{}>;
}
declare namespace DynamoDB {
    enum Operations {
        PUT = "put",
        DELETE = "delete",
        UPDATE = "update",
    }
    interface RetryDelay {
        (msg: any): Observable<number>;
    }
    interface Message {
        operation: Operations;
        params: Object;
        retry?: number;
        retryDelay?: RetryDelay;
    }
    interface IgnorableError {
        code: String;
        message?: String;
    }
    interface Config extends AwsDynamoDB.Types.DocumentClient.DocumentClientOptions, AwsDynamoDB.Types.ClientConfiguration {
        IGNORE_ERRORS?: Array<IgnorableError>;
    }
}
export = DynamoDB;
